#define EN1 5//pin for run the right motor 
#define IN1 4//pin for control right motor direction
#define EN2 6//pin for run the left motor 
#define IN2 7//pin for control left motor direction

#define FORW 0
#define BACK 1

uint32_t timer;
int databuf[8]={};
int miniqspeed=150;
int time=100;

void Motor_Control(int M1_DIR,int M1_EN,int M2_DIR,int M2_EN)
{
  if(M1_DIR==FORW)//M1 motor direction
    digitalWrite(IN1,FORW);//forward
  else
    digitalWrite(IN1,BACK);//back
  if(M1_EN==0)
    analogWrite(EN1,LOW);//stop
  else
    analogWrite(EN1,M1_EN);//set speed

  if(M2_DIR==FORW)
    digitalWrite(IN2,FORW);
  else
    digitalWrite(IN2,BACK);
  if(M2_EN==0)
    analogWrite(EN2,LOW);
  else
    analogWrite(EN2,M2_EN);
}

void addFunction()
{
  int crashsensor_L=digitalRead(10);
  int crashsensor_M=digitalRead(11);
  int crashsensor_R=digitalRead(12);
  if (crashsensor_L==0){
    digitalWrite(8,HIGH);
    buzzer();
  }
  if (crashsensor_M==0){
    digitalWrite(8,HIGH);
    digitalWrite(9,HIGH);
    buzzer();
    
  }
  if (crashsensor_R==0){
    digitalWrite(9,HIGH);
    buzzer();
  }
  else
  {
    digitalWrite(8,LOW);
    digitalWrite(9,LOW);
    digitalWrite(13,LOW);
  }
}

void buzzer()
{
     digitalWrite(13,HIGH); 
     delay(50);     
     digitalWrite(13,LOW); 
     delay(50);
       

}

void setup()
{
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);
  pinMode(13,OUTPUT);
  Serial.begin(115200);
}
void loop()
{
  addFunction();
  if (millis () - timer > time)
   Motor_Control(0,0,0,0);
   if (Serial.available())
  {
    for(int i = 0; i < 10; i++)
    {
      databuf[i] = Serial.read();
      delay(2);
    }
    timer = millis ();
    if(databuf[5] == 0x04){
      time=100;
      Motor_Control(1,miniqspeed,1,miniqspeed);
    }
    else if(databuf[5] == 0x05){
      time=100;
      Motor_Control(0,miniqspeed,0,miniqspeed);  
    }
    else if(databuf[5] == 0x06){
      time=20;
      Motor_Control(1,miniqspeed,0,miniqspeed);
    }
     else if(databuf[5] == 0x07){
      time=20;
    
      Motor_Control(0,miniqspeed,1,miniqspeed);
  }
       
  }
}

